#include "String.h"
#include <ctype.h>

int RJS_StringSearch::search(const RJS_String &s, int &matchlen) const {
		if (ssf) return ssf(s,matchlen);
		else if (str_flag) {
			int pos=s.index(str);
			if (pos==-1) matchlen=0;
			else matchlen=str.length();
			return pos;
		}
		else { matchlen=0; return -1; }
}

int Search_whitespace(const RJS_String &s, int &len) 
{
int p1;
RJS_StringIterator next(s);
char ch;

   while (next(ch)) 
	if (isspace(ch)) {
	      p1=next.pos();
	      while (next(ch) && isspace(ch));
	      len=next.pos()-p1;
	      return p1;
	}
   len=0;
   return -1;

}

int Search_optwhitespace(const RJS_String &s, int &len)
{
int p1;
RJS_StringIterator next(s);
char ch;

	next(ch); 
	if (isspace(ch)) {
	      p1=next.pos();
	      while (next(ch) && isspace(ch));
	      len=next.pos()-p1;
	      return p1;
	}
	len=0;
	return 0;
}

 
int Search_nonwhitespace(const RJS_String &s, int &len) 
{
int p1;
RJS_StringIterator next(s);
char ch;

   while (next(ch)) 
	if (!isspace(ch)) {
	      p1=next.pos();
	      while (next(ch) && (!isspace(ch)));
	      len=next.pos()-p1;
	      return p1;
	}
   len=0;
   return -1;

}

int Search_int(const RJS_String &s, int &len) 
{
len=0;
int pos=0,p1;
RJS_StringIterator next(s);
char ch;
  
   while (next(ch)) if (isdigit(ch) || ch=='-') {
      p1=next.pos();
      while (next(ch) && isdigit(ch));
      len=next.pos()-p1;
      return p1;
   }

   return -1;
 
}

 
int Search_alpha(const RJS_String &s, int &len)
{
int p1;
RJS_StringIterator next(s);
char ch;

   while (next(ch)) 
	if (isalpha(ch)) {
	      p1=next.pos();
	      while (next(ch) && isalpha(ch));
	      len=next.pos()-p1;
	      return p1;
	}
   len=0;
   return -1;

}

int Search_lower(const RJS_String &s, int &len)
{
int p1;
RJS_StringIterator next(s);
char ch;

   while (next(ch)) 
	if (islower(ch)) {
	      p1=next.pos();
	      while (next(ch) && islower(ch));
	      len=next.pos()-p1;
	      return p1;
	}
   len=0;
   return -1;

}

int Search_upper(const RJS_String &s, int &len)
{
int p1;
RJS_StringIterator next(s);
char ch;

   while (next(ch)) 
	if (isupper(ch)) {
	      p1=next.pos();
	      while (next(ch) && isupper(ch));
	      len=next.pos()-p1;
	      return p1;
	}
   len=0;
   return -1;

}


int Search_alphanum(const RJS_String &s, int &len)
{
int p1;
RJS_StringIterator next(s);
char ch;

   while (next(ch)) 
	if (isalnum(ch)) {
	      p1=next.pos();
	      while (next(ch) && isalnum(ch));
	      len=next.pos()-p1;
	      return p1;
	}
   len=0;
   return -1;

}

int Search_id(const RJS_String &s, int &len)
{
int p1;
RJS_StringIterator next(s);
char ch;

   while (next(ch)) 
	if (isalpha(ch) || (ch=='_')) {
	      p1=next.pos();
	      while (next(ch) && (isalnum(ch) || (ch=='_')));
	      len=next.pos()-p1;
	      return p1;
	}
   len=0;
   return -1;

}

int Search_str(const RJS_String &s, int &len)
{
int p1;
RJS_StringIterator next(s);
char ch;

   while (next(ch)) 
	if (ch=='"') {
	      p1=next.pos();
	      while (next(ch) && (ch!='"'));
	      if (ch!='"') break;
	      len=next.pos()-p1;
	      return p1;
	}
   len=0;
   return -1;

}

int Search_strq(const RJS_String &s, int &len)
{
int p1;
RJS_StringIterator next(s);
char ch;

   while (next(ch)) 
	if (ch=='"') {
	      p1=next.pos();
	      while (next(ch) && (ch!='"')) if (ch=='\\') next(ch);
	      if (ch!='"') break;
	      len=next.pos()-p1;
	      return p1;
	}
   len=0;
   return -1;

}
 
int Search_unix_word(const RJS_String &s, int &len) 
{
int p1;
RJS_StringIterator next(s);
char ch;
  
   while (next(ch)) 
	if (!isspace(ch)) {
	      p1=next.pos();
	      do {
		if (ch=='\'') { char last=0;
			while(next(ch)) {
				if (ch=='\'' && last!='\\') break;
				if (ch=='\\' && last=='\\') last=0;
				else last=ch;
			}
		}
		else if (ch=='"') { char last=0;
			while(next(ch)) {
				if (ch=='"' && last!='\\') break;
				if (ch=='\\' && last=='\\') last=0;
				else last=ch;
			}
		}
	      } while (next(ch) && (!isspace(ch)));
	      len=next.pos()-p1;
	      return p1;
	}
   len=0;
   return -1;

}

 
int Search_dcl_word(const RJS_String &s, int &len) 
{
int p1;
RJS_StringIterator next(s);
char ch;
  
   while (next(ch)) 
	if (!isspace(ch)) {
	      p1=next.pos();
	      do {
		if (ch=='\'') { char last=0;
			while(next(ch)) {
				if (ch=='\'' && last!='\\') break;
				if (ch=='\\' && last=='\\') last=0;
				else last=ch;
			}
		}
		else if (ch=='"') { char last=0;
			while(next(ch)) {
				if (ch=='"' && last!='\\') break;
				if (ch=='\\' && last=='\\') last=0;
				else last=ch;
			}
		}
	      } while (next(ch) && !isspace(ch) && ch!='/' );
	      len=next.pos()-p1;
	      return p1;
	}
   len=0;
   return -1;

}

const RJS_StringSearch SSwhite(Search_whitespace);
const RJS_StringSearch SSoptwhite(Search_optwhitespace);
const RJS_StringSearch SSnonwhite(Search_nonwhitespace);
const RJS_StringSearch SSint(Search_int);

// const RJS_StringSearch SSdouble(Search_double);

const RJS_StringSearch SSalpha(Search_alpha);
const RJS_StringSearch SSlower(Search_lower);
const RJS_StringSearch SSupper(Search_upper);
const RJS_StringSearch SSalphanum(Search_alphanum);
const RJS_StringSearch SSid(Search_id);
const RJS_StringSearch SSstr(Search_str);
const RJS_StringSearch SSstrq(Search_strq);

const RJS_StringSearch SSunix_word(Search_unix_word);
const RJS_StringSearch SSdcl_word(Search_dcl_word);

