#include "String.h"

inline void concat(RJS_StringData &sd,const char *s1,int l1, const char *s2,int l2)
{
  memcpy(sd.data,s1,l1);
  memcpy(sd.data+l1,s2,l2);
  sd.len=l1+l2;
  sd.data[sd.len]='\0';
}

RJS_String RJS_String::operator + ( char c) const
{
RJS_String temp(RJS_StringRange(length()+1)); // make a string for result
  concat(temp.sd,cptr(),length(),&c,1);
  return temp;
}

RJS_String RJS_String::operator + (const char *s) const
{
int slen=RJS_String::length(s);
RJS_String temp(RJS_StringRange(length()+slen)); // make a string for result

  concat(temp.sd,cptr(),length(),s,slen);
  return temp;

}

RJS_String RJS_String::operator + (const RJS_String &s) const
{
RJS_String temp(RJS_StringRange(length()+s.length())); // make a string for result

  concat(temp.sd,cptr(),length(),s.cptr(),s.length());
  return temp;

}



RJS_String operator + ( char c,const RJS_String &s1) 
{
RJS_String temp(RJS_StringRange(s1.length()+1)); // make a string for result

  concat(temp.sd,&c,1,s1.cptr(),s1.length());
  return temp;

}

RJS_String operator + (const char *s, const RJS_String &s1)
{
int slen=RJS_String::length(s);
RJS_String temp(RJS_StringRange(s1.length()+slen)); // make a string for result

  concat(temp.sd,s,slen,s1.cptr(),s1.length());
  return temp;

}
